intro

DirectLoad is software which enables a file created in MS Word to be exported from the local machine and loaded onto a website in one very simple operation!

This is a tool which makes it easier than ever before for people with no knowledge of website structure or language to maintain their own presence online! It is perfect for intranets too!

All the client needs is MS Word 2000 or better and a standard Internet connection. No FTP. No HTML. No other software packages. No messing around - the files you DirectLoad from MS Word just appear on the website!

DirectLoad consists of two parts, the DirectLoad client - a special template for MS Word 2000 installed as an add-in on your system, and the DirectLoad server, (currently only available as a Cold Fusion template) which collects the files you send and puts them on the website.

DirectLoad will convert files into HTML and send them (together with associated images) to the website. Optionally it will send native MS Word files and other format files such as Adobe Acrobat or MPEG Video.

Depending on the setup, HTML formatting can be controlled such that the loaded file can be all or partially forced to comply with the style of the website.

So easy, only telepathy is simpler!

DirectLoad is freely available for your evaluation though it has some limitations. Once you have purchased DirectLoad the licence is Royalty free which means that (within the terms of the licence agreement) you can freely distribute your own applications containing DirectLoad.

As a point of interest, all the files in this Help file were created on our company Intranet using DirectLoad

Enjoy!


About DirectLoad Client

DirectLoad Client

DirectLoad Client is a special MS Word document template (Compatible with MS Word 2000 / v.9 or better) with some special code which, when installed as an add-in enables it to sent files via HTTP to a web server equipped with DirectLoad Server.

It is designed to be very easy to use.


Installing DirectLoad Client

System requirements

MS Windows 95/98/millenium/NT4/2000 or better.

MS Word 2000 (v9) or better

Install

Download the latest version of DirectLoad from http://www.flymicro.com/cf/directload

Double click on the file DLsetup.exe This will install the necessary files and place some shortcuts in Start --> Programs --> DirectLoad

The default directory is C:\Program Files\DirectLoad

Once you have installed DirectLoad you can use it straight away.

If a newer version of DirectLoad is released there is no need to uninstall your current version, simply install the latest version of DLsetup.exe and all files will be inserted, updated or replaced as necessary.


Using DirectLoad

Using DirectLoad client

Open Microsoft Word ® and install DirectLoad as an Add-In . more….

Open a word file and edit it as necessary. more….

When you are ready to DirectLoad the file:

Select DirectLoad from the main menu.

If this is the first time you have used Directload then the Settings box will pop up first. Enter the site name (any name of your choice) and the URL and click OK. more…

You are then presented with the main DirectLoad dialog box. (Note, there are limitations in the evaluation edition). How to register DirectLoad.

Select the site you want to DirectLoad to.

Select Load / Overwrite, Rapid overwrite or Remove.

Rapid overwrite does not send images in HTML files and so is much faster. more….

Removing files from the web server will not affect your local files at all. more….

Select a section to load this file into.

If this is the first time you have used DirectLoad in this template you will need to Update Sections first. By updating sections you download all the available sections from the Server, you can do this at any time, but the sections are automatically updated every time you successfully DirectLoad any file. more…

Select a file type to load.

Of the three available choices of text format, HTML makes the smallest files (and hence the fastest to load in a browser), followed by Native MS Word (.doc), followed by Adobe Acrobat (.pdf).

DirectLoad will also load Mpeg Video files (.mpg)

Enter your Password.

This is the password which allows you to load files onto the website. more....

Click OK (or press the enter key)

If nothing happens and/or there is a beep, try holding down the OK button with your mouse. If something is wrong a warning message will appear in the box concerned. Otherwise your file will be immediately DirectLoaded!

Notes:

Depending on your windows and internet connection setup, you may already have to be ‘on line’ before you click OK or DirectLoad will time out before a connection is established.

If you have Word open in multiple windows, all the other windows get minimized.

A message is returned from the DirectLoad server indicating the result of your DirectLoad.

So easy, only telepathy is simpler!


Installing DirectLoad as an add in

Installing DirectLoad as a Microsoft Word ® Add-In

In Microsoft Word ® go to Tools --> Templates and Add-ins

Click on Add…

Navigate to the location of the DirectLoad template file (Default install = C:\program files\Directload\DLxx.dot). The template file is named DLxx.dot where xx represents the latest release number.

Click OK, the template should now be in your list of Global templates and add-ins.

Notice that it says Checked items are currently loaded, make sure the DirectLoad template is checked.

Click OK. If DirectLoad is successfully installed as an Add-in a DirectLoad main menu item should be apparent at the top of the window.

DirectLoad as a permanent Add–in

There is one catch with the default installation: DLxx.dot will remain as a ‘live’ add-in for the session you have Word going, but it will have disappeared from the menu next time you start Word and you will have to go to Tools --> Templates and Add-ins and re-check DLxx.dot As MS Word help says “Where you've stored the template or add-in determines whether it's loaded when you start Word”

To have DirectLoad loaded each time you start Word, copy DLxx.dot to your Microsoft Office Startup folder. You can find out where this is by going to Tools --> Options --> File locations and inspecting the File type location Startup


Setting the URL

Settings

Site

The site name can be anything of your choice (except blank).

URL

The destination URL should be a fully formed URL in the form:

http://www.yoursite.com/page_which_collects_the_data.cfm

Your network administrator will give you the correct URL.

Both Site name and URL can be edited at any time.

Click OK to return to the main DirectLoad Dialog box.

Multiple Sites

(Not available in evaluation versions, see evaluation limitations.)

Add a site

If you have more than one site you can DirectLoad to, then it is simple to add them to your DirectLoad settings; simply press the Add site… button and enter the name and URL of the new site.

Click OK

The new site will be available as an option in the Site box in the main DirectLoad dialog-box.

Delete a site

If you no longer need the setting for a particular site, click on Del site and that site will be removed. If the Del site button is not available then you can edit the site name and URL to a different one.


Setting the action

Load / Overwrite

The file (plus any embedded images, if it is a HTML file) will be DirectLoaded, and if the file was previously DirectLoaded, then the existing files will be overwritten.

Rapid overwrite

Only applies to HTML files.

If you alter the text content of the file, but not the file name, the destination section or the position, content or size of any embedded images, it should not be necessary to re-DirectLoad the images. The Rapid overwrite option DirectLoads the file but not the images and will be much faster to complete.

Note that if the file has no embedded images, then there is no difference between the Load / overwrite and the Rapid overwrite actions.

Remove

Selecting this will delete the file from the web server (plus any associated image files).

It will not affect the files on your local system in any way.


Update Sections

Your website administrator will have set up the site with one or more sections into which the file you are editing may be loaded.

To get the current set of sections from the server, select the menu item Update Sections. A message is displayed under the OK button if the download was successful.

Once a file has been DirectLoaded once, the section it was loaded into is saved with the document and recalled next time you want to DirectLoad the document.


About passwords

Passwords

The password you should use should be given to you by your Website Administrator.

DirectLoad passwords are case sensitive.

For your convenience, your password is remembered between DirectLoads if:

1) No longer than 30 minutes has passed since the last time you used DirectLoad

2) At least one instance of a document based on the DirectLoad template is running.

3) The server recognises the password as valid.

Otherwise you have to type in your password in the password box.


How to register DirectLoad

If you are running the evaluation version of DirectLoad, you can immediately upgrade to the Licenced version with no limitations.

If your Website administrator does not have the licence key for your application then you will need to purchase a licence.

From the main DirectLoad dialog box select Register Now! or from the main MS Word window select Help --> About Directload.

Simply enter your licence number in the box provided and Press the Register button. Agree to the Licence conditions and, if the number is valid, all limitations will be immediately removed from your copy of DirectLoad.


Limitations of the evaluation version

See also: Purchase DirectLoad, How to register DirecLoad

Limitations of the evaluation version of DirectLoad:

1. The evaluation version of DirectLoad will collect and list multiple site sections as a demonstration of DirectLoad's functionality, but DirectLoad client and DirectLoad Server will only permit the user to load the file into the first section on the drop-down list.

2. DirectLoad will show the ability to load native MS Word files (.doc) and, if they exist, Adobe Acrobat (.pdf) files, but DirectLoad client and DirectLoad Server will only permit HTML files (and any associated images) to be loaded to the server.

3. DirectLoad does not allow multiple sites.


Getting the best out of DirectLoad

One of the keys to good web design is to keep files small. This allows rapid downloads and makes for happy website users. When used to maintain a HTML website DirectLoad will convert anything you create in MS Word as best it can into HTML but unfortunately MS Word in it’s standard “save as web page” mode is capable of creating hugely verbose (ie big) HTML files.

Styles

Both DirectLoad client and DirectLoad server do their best to reduce the file sizes in the DirectLoad process, but there are a lot of things the user can do to keep file sizes down, notably tight control of the styles used in the document. This also will aid the Website administrator in keeping a consistent look and feel to the site. more....

Directory structure & Hyperlinks

It is recommended that the user create a local directory structure which reflects the one on the web server. In this way it is easier to construct hyperlinks correctly. more…

Embedded images

Images embedded in the document will get DirectLoaded correctly but there are hazards. more…

Headers & Footers

When generating HTML files, DirectLoad does not include any information from the header or footer of a document in the generated HTML file, but it will still load any images therein….. It is therefore recommended that you do not insert any images (eg Company Logo Etc) in the header or footer of a template or one or more images will be DirectLoaded every time unnecessarily.


A note about Styles

The style information in the underlying template is sent in embedded cascading stylesheet form to the web site and are very useful because the website administrator has the ability to maintain a consistent look and feel through the use of a global stylesheet. (ie if a property of a particular style is defined in the global stylesheet then it will take precedence over that definition in the embedded stylesheet.)

This can be defeated by the user defining his own styles or by inadvertent insertion of extraneous styles with names which the website administrator hasn’t pre-defined. A good DirectLoad installation should therefore include a template which the editor consistently uses to create files which has the appropriate styles for the website embedded in it.

Copying text from another MS Word document and pasting it into a file to be DirectLoaded is the easiest way to fill a document up with extraneous styles which may have the undesirable effects of both making the file larger (because it will contain all the extra style information) and upsetting your Website administrator because you have inserted new styles not covered by his global stylesheet.

Solution: The DirectLoad template provides the menu option: Edit --> Paste As Pure Text. By using this option the text you copied will be inserted without any extraneous style information. You may then apply the styles provided in the template to the text.


Hyperlinks

Hyperlinks can be inserted in a MS Word document (Insert --> Hyperlink ) and they should function correctly on the website.

Hyperlinks to “external” web pages (i.e. a fully qualified URL e.g. http://www.flymicro.com/cf/directload ) can be inserted as normal, the easiest way to do this is to go the page in question in your browser, highlight the address (URL) , copy it using the keystrokes Crl-C and pasting this URL into the box which says ‘Type the file or web page name’.

Care must be taken however with “internal” links to other pages in the same website because the “relative path” that the hyperlink needs may not be the same as the path to a local file on your local computer.

It is suggested that you set up your local files in a directory structure which is a mirror of the setup on the website. Your Website administrator should be able to advise you on this. You can then fairly easily simulate the relationships between files in different sections on the website and use the MS Word “Insert Hyperlink” function reliably.

It is important to understand how DirectLoad names files so you can get your hyperlinks correct.


Embedded images

Images can be pasted into a document or inserted using Insert --> picture … and they will be DirectLoaded correctly. However, if the image is subsequently re-sized in Word you will find two images are DirectLoaded, not one. This is a quirk of MS-Word – it retains the original image and this will be DirectLoaded as well even though it is not used. This could be a problem if the original is a big file and is totally unnecessary as this image is not used on the website.

It is therefore recommended that you size the image as appropriate before you insert it into the document.


DirectLoad weird behaviour

See also: The Errors log file

Weird client behaviour (or solutions to some problems…)

1) I get the message "Macros not found" or a similar error message.

The DirectLoad add-in template contains all the DirectLoad code so this error is to do with your local MS Word installation rather than something which can't be found.

Solution 1: Your Macro security settings are set too high. (See Tools --> Macro --> Security --> Security level) .Try reducing the Security level to "medium". You will have to shut down Word and restart it again for your new security setting to take effect.

Solution 2: If you don’t want to reduce your Macro security settings, try copying the DirectLoad template to the same directory as all your other document templates (see Tools --> Options --> File locations), create a new document (File --> New) and re-installing DirectLoad as an add-in from there.

2) I clicked OK but nothing seemed to happen

Sometimes, the very first time you run DirectLoad after an install, nothing happens after you click OK.

Solution: Just run DirectLoad again and everything should run as normal.

3) Clicking on the OK button in the main DirectLoad dialog box does nothing

If you get a beep as well then you have not selected either a valid section OR a valid File type OR the password field is blank.

Solution: Press the OK button with your mouse and keep it down. If you have not selected something in either the Sections box, the Format box or left your password blank then a red warning message appears in the box concerned.

4) I seem to be loading more images than are in my document.

If you insert an image in your document and then re-size it, word retains both the original and the new versions of the image. more…

Solution: Convert the image to the size you want in another program outside Word before you insert it into the document. This way Word only needs one image.

5) There are no images in my document but DirectLoad is telling me I have successfully loaded one.

Don’t have images in the Document header or footer. (eg a company logo). more…

6) DirectLoad seems to have changed the way my document looks on screen

Solution 1: The view has changed. To revert back to the one you were in, select View --> [the view you were in before]. This behaviour can occur when you have more than one file open at a time.

It is preferable to run DirectLoad when you have only one file open at any one time.

Solution 2: It is possible that you are in HTML editor mode. Close the window and open an MS Word format file.

DirectLoad is designed to work with MS Word format source files (.doc) not HTML source files (.htm). To see the full file name see File --> Properties --> General

7) DirectLoad seems to have loaded the wrong file.

This problem is associated with multiple files based on the DirectLoad template being open at a time.

DirectLoad will load the file which is in the background at the time the main DirectLoad dialog box is active. DirectLoad will not inadvertently send a file with the site, section or format details of a different file.

What may have happened is that you were in one window, selected DirectLoad and the active window switched to another file before the DirectLoad dialog box popped up.

Solution 1: To ensure the “active” document is DirectLoaded, edit it first. This may mean simply adding (or deleting) a space in the text.

Solution 2: Cancel DirectLoad by clicking on the X at the top left of the DirectLoad dialog box and close the file you didn’t want to load.


How DirectLoad names files

The file which gets sent to the DirectLoad server has exactly the same name as the file which was saved on your local system apart from two important differences:

1. No spaces are permitted in URL’s so spaces are always replaced_with_underscores.

2. Files converted to HTML have the new suffix .htm (not .doc)

For example:

· My big word document.doc if DirectLoaded in HTML Format is renamed My_big_word_document.htm

· My big word document.doc if DirectLoaded in MS Word format is renamed My_big_word_document.doc

If you are DiretLoading other format files e.g. Adobe Acrobat or MPEG video then you should take care to correctly name the file you place in the DirectLoad_Files sub directory; My big document.pdf should be named My_big_document.pdf


HTML Format

HTML (HyperText Markup Language) is the native language of the web. DirectLoad converts the MS Word file into HTML and loads it, plus any associated image files to the appropriate section on the website.

Of the three available choices of format, HTML makes the smallest files (and hence the fastest to load in a browser), followed by Native MS Word (.doc), followed by Adobe Acrobat (.pdf).


MS Word Format

Native MS Word Format

The file saved on the website is exactly the same as the one being edited.

Of the three available choices of format, HTML makes the smallest files (and hence the fastest to load in a browser), followed by Native MS Word (.doc), followed by Adobe Acrobat (.pdf).


Adobe Acrobat Format

Adobe Portable Document Format (.pdf) files are a common addition to web sites. DirectLoad does not create PDF files, for this you need Adobe Acrobat Distiller installed on your system.

The default Acrobat installation in Windows includes a macro—Adobe PDFMaker that allows you to create Adobe PDF files quickly and easily from within Microsoft Office applications. PDFMaker works with Word 2000 and is installed automatically if you had the Microsoft Office application on your system when you installed Adobe Distiller.

By default Adobe PDF files created with PDFMaker generate tagged PDF and preserve hyperlinks, styles, and bookmarks present in the source document.

To convert a Microsoft Office application document to PDF, choose Acrobat > Convert to

Adobe PDF from your Microsoft Office application menu bar.

Save it as exactly the same file name as the source file (except it is .pdf rather than .doc) in the DirectLoad_Files sub-directory of the current files’ location.

When the .pdf file exists in the DirectLoad_Files sub-directory, you will be given the option to load that file to the website.

Of the three available choices of text format, HTML makes the smallest files (and hence the fastest to load in a browser), followed by Native MS Word (.doc), followed by Adobe Acrobat (.pdf).


Mpeg Video Format

Mpeg Video Format (.mpg) files are sometimes added to web sites, though they are often very large files. DirectLoad does not create Mpeg files, for this you need some sort of video editor program installed on your system, but it will load them to a website in the same way as it will load Adobe Acrobat (.pdf). files.

To directLoad a .mpg file, save a document, for example, as ‘my video.doc’

Place or save a file named ‘my_video.mpg’ in the DirectLoad_Files sub-directory of the current files’ location. (note the added underscore in the name)

When the .mpg file exists in the DirectLoad_Files sub-directory, and you DirectLoad the document, you will be given the option of MPEG Video (.mpg) in the file type to send option box.

Select that, and the .mpg file will be DirectLoaded to the website. (not the .doc file)


Uninstalling DirectLoad Client

The default install includes a shortcut from the start menu: Start --> Programs --> DirectLoad --> Uninstall or click on Uninstall.exe in the directory selected by the user during install (Default: C:\Program Files\DirectLoad).

All files and shortcuts installed during setup will normally be removed from the user’s system.


Files installed with DirectLoad Client

When you run DLsetup.exe the following files will be installed:

In the directory selected by the user during install

Default: C:\Program Files\DirectLoad

· DLxx.dot: The MS Word DirectLoad template (xx indicates the version number)

· Readme.txt: Late breaking information about DirectLoad

· Licence.txt: The DirectLoad license agreement.

· DirectLoad.chm: The DirectLoad Help file.

· DirectLoadErrors.log: Logs errors received from the server.

· Uninstall.exe: The uninstall executable.

· Uninstall.ini: Uninstall information for uninstall.exe.

In the windows/system (or system32) Directory:

· HttpX.dll: Library of HTTP functions used to send files to the Website

· Mabryobj.dll: Library of functions used to send files to the Website

· Filter.exe: A Microsoft supplied file which cleans up the XML generated by MS Word when it makes HTML files.

If a newer version of DirectLoad is released there is no need to uninstall your current version, simply install the latest version of DLsetup.exe and all files will be inserted, updated or replaced as necessary.


About DirectLoad Server

The DirectLoad system is a method of getting data from a special MS Word template on the local client box (DirectLoad client) onto a web server equipped with DirectLoad server.

Although many different formats may be supported, presently DirectLoad server is only available for Cold Fusion 4.5.1 or better. Some programming of the interface with DirectLoad is required.

The latest version of DirectLoad Server is always available on the DirectLoad Website: http://www.flymicro.com/cf/directload


Deploying DIRECTLOAD Server

Deploying DirectLoad Server in Cold Fusion

DirectLoad server will function in Cold Fusion v. 4.5.1 or better. It is a custom tag (DirectLoad.cfm) which should be embedded in the file which is called from DirectLoad client (the i/o template).

The i/o template may be placed anywhere on the web server and named anything. (The example file is collect_data.cfm).

The url in the DirectLoad client settings should point directly at this file.

No hyperlinks from any other file on the web should point at it.

The i/o file should contain the CF_DirectLoad custom tag.

The CF_DirectLoad custom tag outputs various variables which can be used for post-processing, e.g. to update a database or a Verity collection.


Installing DirectLoad Server

System requirements

Cold Fusion 4.5.1 or better running on a suitable web server.

Install

All you need to do is place the i/o file and DirectLoad.cfm on your Cold Fusion enabled website.

Some programming of the i/o file parameters will be required.

A complete working model is available on the DirectLoad website.

Unzip the file to a suitable sub-directory under the root of your web server. It should create a few sub-directories. The URL you will need to enter in DirectLoad client is http://your.server.name/your_subdirectory/collect_data.cfm and the password is mypass

The URL to view the result in your browser is

http://your.server.name/your_subdirectory/index.cfm


The i-o file

See also: CF_DirectLoad syntax

The i/o template

DEPLOYMENT

The i/o template may be placed anywhere on the web server and named anything. (The example template is collect_data.cfm). The URL in the DirectLoad client settings should point directly at this file. No hyperlinks from any other file on the web should point at it.

Unless there is an error CF_DirectLoad does not return any body information so anything output in Application.cfm or OnRequestEnd.cfm should not affect DirectLoad functionality. If there is an error the entire body text is returned to the client and (if the file exists) inserted in DirectLoadErrors.log on the client which the developer can read for debug purposes. It is therefore prudent to make sure that output in Application.cfm is not included in any call to DirectLoad.

<CFSETTING ENABLECFOUTPUTONLY = "Yes">

<CF_DirectLoad

SiteSectionsList = "Compulsory, a comma delimited list"

SiteSectionsAliasList = "Compulsory, a comma delimited list"

PWList = "Compulsory, a comma delimited list"

AcceptedFileTypes = "Optional comma delimited list"

StripHTML = "Optional, 0 or 1 or 2 or 3 or 4 or 5"

MakeSafeHTML = "Optional, 0 or 1 or 2 or 3 or 4 or 5 or 6"

ImgLoadPath = "Optional, a relative path"

ImgReadPath = "Optional, a relative path"

InsertBaseHREF="1" Optional, default = "0"

HeaderFile = "http://#cgi.server_name#/my_header.cfm" Optional, Default = ""

FooterFile = "http://www.another-server.com/the_footer.htm" Optional, Default = "">

<!--- Uncomment the following block to output all the returned variables to the file ReturnVars.txt --->

<!---

<CFFILE ACTION="WRITE" FILE="#expandpath('ReturnVars.txt')#" OUTPUT="DLresultmsg: #DLresultmsg# #chr(10)#DLfileName: #DLfileName# #chr(10)#DLdestFilePath: #DLdestFilePath##chr(10)#DLDestRelPath: #DLDestRelPath# #chr(10)#DLimgnamelist: #DLimgnamelist# #chr(10)#DLdestImgPath: #DLdestImgPath# #chr(10)#DLresultaction: #DLresultaction#"> --->

<CFSETTING ENABLECFOUTPUTONLY = "No">


CF DirectLoad syntax

The CF_DirectLoad custom tag

The tag is inserted somewhere in the i/o template.

SYNTAX

<CF_DirectLoad

SiteSectionsList = "Compulsory, a comma delimited list"

SiteSectionsAliasList = "Compulsory, a comma delimited list"

PWList = "Compulsory, a comma delimited list"

AcceptedFileTypes = "Optional comma delimited list"

StripHTML = "Optional, 0 or 1 or 2 or 3 or 4 or 5"

MakeSafeHTML = "Optional, 0 or 1 or 2 or 3 or 4 or 5 or 6"

ImgLoadPath = "Optional, a relative path"

ImgReadPath = "Optional, a relative path"

InsertBaseHREF="1" Optional, default = "0"

HeaderFile = "http://#cgi.server_name#/my_header.cfm" Optional, Default = ""

FooterFile = "http://www.another-server.com/the_footer.htm" Optional, Default = "">

SiteSectionsList

Compulsory. A comma delimited list matching SiteSectionsAliasList (ie listItem 1 = 1, 2 = 2 Etc) where each list item is the relative path to that SiteSection from the i/o template. At least one list item required, spaces not allowed.

SiteSectionsAliasList

Compulsory. Comma delimited list of descriptive names of possible site sections the file can be loaded into. At least one list item required, spaces OK. This is the list of items which appear in the Client's section select box. List length must be the same as SiteSectionsList.

PWList

Compulsory. Comma delimited list of acceptable passwords. At least one list item required, spaces OK.

AcceptedFileTypes

Optional. A list; default = “htm,pdf,mpg”. DirectLoad will load files of types .htm,.doc,.pdf and .mpg if you don't want user to be able to load a file type, leave it off your list. Type .doc is not a default type because of the possibility it could contain malicious macros.

StripHTML

Optional. 0 or 1 or 2 or 3 or 4 or 5, default = “2”. If it is a comma delimited list of numbers and the list length is the same as that of SiteSectionsList then that option is applied to that site section. Otherwise just the first number applies for all.

Option 0 simply loads the file into the destination directory exactly as it left the DirectLoad client.

Option 1 tidies up the HTML and strips out a lot of the XML that MS Word creates, but the <HTML><HEAD></HEAD><BODY></BODY></HTML> tag structure is retained so the file is syntactically correct for viewing on it's own.

Option 2 strips out everything except style sheet and body html so the resultant file is suitable for CFINCLUDEing in another file on the site.

Option 3 is as option 2 but only body information is included in the resultant file.

Option 4 replaces <BR> with one line return and <P> with two line returns and strips out all other HTML tags so the file is effectively DirectLoaded as text only.

Option 5 strips out all HTML tags and all non-printing characters eg line returns. Resultant file can be used as content for a Meta tag for example.

MakeSafeHTML

Optional. 0 or 1 or 2 or 3 or 4 or 5 or 6, default = 6. So long as the file being DirectLoaded is a HTML file (this attribute has no effect on other files) then it is possible the DirectLoader could embed (inadvertently or deliberately) dangerous code in the HTML code being loaded. This attribute (which is independant of any StripHTML option) strips out potentially dangerous code.

Option 0: Deactivates the MakeSafeHTML functions.

Option 1: Removes all <CF...> tags

Option 2: Option 1 + removes dangerous HTML tags eg APPLET, OBJECT, EMBED, FRAME, FRAMESET, IFRAME, ILAYER, LAYER, META, PARAM, SERVER.

Option 3: Options 1 & 2 + removes entire <SCRIPT></SCRIPT> blocks.

Option 4: Options 1, 2 & 3 + removes FORM and form associated tags eg BUTTON, FORM, INPUT, KEYGEN, OPTION, SELECT, TEXTAREA.

Option 5: Options 1, 2, 3 & 4 + removes 'javascript:' and 'vbscript:'

Option 6: (Default) Options 1, 2, 3, 4 & 5 + Disables DOM event handlers by changing them to innocent xxx attribute that gets ignored by the browser eg onabort, onchange, onclick, onafterupdate, onbeforeunload.

ImgLoadPath

Optional. A relative path from the i/o template to the directory in which the image files are saved; default = the same directory as where the associated file is saved.

ImgReadPath

Optional. A relative path to place images when reading. default = the same directory as where the associated file is saved.

The difference between ImgLoadPath and ImgReadPath is quite subtle: The ImgReadPath is a physical modification of the actual file which is loaded so that if a file is read as an INCLUDE in another file, the path to he image remains correct.

A special value “$SiteSection$” can be used in IngLoadPath or ImgReadPath. It is interpreted by DirectLoad to mean 'insert the same path to the image as the one to the file here' (i.e. the value of the return output variable DLDestRelPath)

InsertBaseHREF

If StripHTML = "1" (ie a complete but stripped html file is written) then if InsertBaseHREF="1" the string <BASE HREF ="http://#cgi.server_name#"> is written to the <HEAD></HEAD> section of the DirectLoaded file. #cgi.server_name# is resolved to the server name (eg www.flymicro.com). This BASE HREF tag sometimes helps to resolve image path problems.

HeaderFile and FooterFile

If StripHTML = "1" (ie a complete but stripped html file is written) then a header and/or footer can be retrieved and inserted into the DirectLoaded file immediately after the <BODY> tag and immediately before the </BODY> tags respectively. The values of HeaderFile and FooterFile MUST be a complete URL (including the http://). Note that because they are collected by HTTP the files can contain dynamic content eg 'Page updated #dateformat(now(),"d mmm yyyy")#' and 'Page updated 1 Jan 2003' will be written to the file being DirectLoaded. Beware of output from application.cfm or OnRequestEnd.cfm as this will get included too! If either of these functions fail, no error is presented in DirectLoad client, but a message like <!-- DirectLoad footer insert failure: 404 Not Found --> will be written to the source of the DirectLoaded file.

RETURN OUTPUT

Directload generates various variables which may be used to write to a db on the server or to update a verity search collection:

DLserverVersion: Version number of DirectLoad server

DLresultmsg: The message returned to the DirectLoad client

DLdestFilePath: The full path to the DirectLoaded file ("" if fail)

DLDestRelPath: The relative path to the DirectLoaded file ("" if fail, ie this is the selected path from SiteSectionList)

DLFileName: The name of the DirectLoaded file ("" if fail)

DLdestImgPath: The full path to where the images are saved

DLimgnamelist: A comma delimited list of images loaded ("" if none)

DLresultaction: A comma delimited 2 element list;

Successful actions: One of:

“OK,returnsections”

“OK,loadHTMLdata”

“OK,loadDOCdata”

“OK,loadOTHERdata”

“OK,updateHTMLdata”

“OK,updateDOCdata”

“OK,updateOTHERdata”

“OK,deldata”

Failures, one of:

“fail,SiteSectionListsWrong” (An i/o file setup problem, zero length or inconsistency between lengths of SiteSectionAliasList and SiteSectionList)

“fail,NoPasswords” (An i/o file setup problem, no possible passwords are given)

“fail,DestDirNotFound” (An i/o file setup problem, the directory where a file should be placed doesn’t exist)

“fail,DestSectionNotFound” (The client’s requested section no longer exists)

“fail,FileTypeNotAllowed” (Administrator has disabled loading this file type)

“fail,UnknownClientRequest” (Request from Client has probably been corrupted in some way)

“fail,BadPW” (The client sent an unrecognised password)

“fail,BadFileName” (file name should be my_file.xxx error probably raised by extra . in name)

“fail,FileNotFoundToDelete” (Client tried to delete a file which is not on the server)

“fail,NoFileContent” (Request from Client has probably been corrupted in some way)

“fail,EvaluationActionNotPermitted” (Client tried to load a non .htm file with the evaluation version)

“fail,ServerSyntaxError” (Some sort of syntax error within the DirectLoad.cfm file. Please report these to directload@flymicro.com )

EXAMPLE

<CFSETTING ENABLECFOUTPUTONLY = "Yes">

<!--- Below is a fully functional example, as used in the model site

note that in this case all the input variables are 'hard coded' but normally they would be

generated dynamically.

--->

<CF_DIRECTLOAD

SiteSectionsList = "demo_section_1,demo_section_2"

SiteSectionsAliasList = "Demo section one,Demo section two"

PWList = "demo"

StripHTML = "2"

ImgLoadPath = ""

ImgReadPath = "$SiteSection$">

<!--- Uncomment the following block to output all the returned variables to the file ReturnVars.txt --->

<!---

<CFFILE ACTION="WRITE" FILE="#expandpath('ReturnVars.txt')#" OUTPUT="DLresultmsg: #DLresultmsg# #chr(10)#DLfileName: #DLfileName# #chr(10)#DLdestFilePath: #DLdestFilePath##chr(10)#DLDestRelPath: #DLDestRelPath# #chr(10)#DLimgnamelist: #DLimgnamelist# #chr(10)#DLdestImgPath: #DLdestImgPath# #chr(10)#DLresultaction: #DLresultaction#"> --->

<CFSETTING ENABLECFOUTPUTONLY = "No">


The errors log file

So long as the file DirectLoadErrors.log exists in the Client’s install directory (default = C:\Program Files\directload) then if DirectLoad client encounters an error response from the server then the error is written to this log file.

This file may be used by the system administrator to try to resolve the fault. For each error, the log file contains:

The date and time

When the error occurred.

The error code

00: A bad error, probably in the developer’s syntax in the i/o file , Application.cfm or OnRequestEnd.cfm but possibly in the syntax of DirectLoad.cfm itself. In any case it was not trapped by the <CFTRY><CFCATCH> block in this file.

01 or 10: An error trapped by the <CFTRY><CFCATCH> block in DirectLoad.cfm

The error message

The raw text of the error message returned by Cold Fusion.

If it appears that the problem is with the DirectLoad.cfm file itself, please contact directload@flymicro.com with details of the error.


Other server interfaces

There is no reason why DirectLoad Client can’t work perfectly well with other server interfaces such as ASP, PERL or PHP. If you, as a developer in one of these languages and are interested in collaborating in the construction of a DirectLoad server interface in any of these languages then please contact rmh@flymicro.com


Licence agreement

DirectLoad licence agreement

GRANT OF LICENCE

TAME Ltd grants a license to use the enclosed software to the original purchaser. This product is licensed for use by only one developer at a time. TAME Ltd expressly prohibits installing this product on more than one computer if there is any chance that both copies will be used simultaneously. This restriction also extends to installation on a network server, if more than one workstation will be accessing the product.

Copies may be made for back-up purposes only. Copies made for any other purpose are expressly prohibited. Adherence to this requirement is the sole responsibility of the purchaser.

This license may be transferred to a third party only if all existing copies of the software and its documentation are also transferred.

The evaluation versions of our products are intended for trial purposes only and their performance may be limited in some way. You may not use the evaluation version in completed applications.

ROYALTY FREE LICENCE AGREEMENT

Customer written applications containing embedded TAME Ltd. products may be freely distributed without royalty payments to TAME Ltd provided that such TAME Ltd product is bound into these applications in such a way as to prevent use in design mode, and that such TAME Ltd product is distributed only in conjunction with the customer's own software product. The TAME Ltd product may not be distributed by itself in any form.

Neither source code for TAME Ltd products nor modified source code for TAME Ltd products, nor third party components of TAME Ltd products may be distributed under any circumstances.

WARRANTY

This software is provided 'as is'. TAME Ltd makes no warranty, expressed or implied, with regard to the software. All implied warranties, including the warranties of merchantability and fitness for a particular use, are hereby excluded.

TAME Ltd's LIABILITY IS LIMITED TO THE PURCHASE PRICE. Under no circumstances shall TAME Ltd or the authors of this product be liable for any incidental or consequential damages, nor for any damages in excess of the original purchase price.

To be eligible for free technical support via the Internet and to ensure that you are notified of any future updates, please complete the registration form on the DirectLoad website.

TRADEMARK NOTICE

'TAME Ltd web fab', 'DirectLoad' and respective logos are trademarks of TAME Limited. All other names and brands are the property of their respective owners.

COPYRIGHT

The source code of DirectLoad Client and DirectLoad Server are (c) 2001 RMH(Richard Meredith-Hardy)

OTHER TERMS AND CONDITIONS

No failure of forbearance on the part of the Publisher to exercise its rights or insist upon performance of the obligations herein is to be construed as a waiver or relinquishment of these rights or obligations and the same shall remain in full force and have full effect.

These Terms and Conditions do not affect the any person's statutory rights under English law which cannot be altered by the specific Terms and Conditions as stated herein.

If any of these Terms and Conditions is deemed unlawful, void or unenforceable for any other reason, such provision shall not invalidate or make the remaining Terms and Conditions unenforceable and the Terms and Conditions shall be amended to reflect the intent of the parties as expressed by the Terms and Conditions herein. If such amendment is impossible, severed from these Terms and Conditions.

JURISDICTION

These Terms and Conditions shall be governed by and construed in accordance with the law of England and Wales. You agree to submit to the exclusive jurisdiction of the courts of England and Wales with respect to any claim or action arising out of or in connection with the Terms and Conditions, the software, third party software associated with the software and any other materials contained in the support website or installation file and agree not to commence or continue any claim or action except in the aforementioned courts.


Purchase DirectLoad

Purchasing a DirectLoad licence

Please go to the DirectLoad Website: http://www.flymicro.com/cf/directload

Email support

directload@flymicro.com


Copyright information

DirectLoad Client

VBA code in the template: © Richard Meredith-Hardy 2001-2002 rmh@flymicro.com

DirectLoad Server

All Cold Fusion templates supplied in association with DirectLoad: © Richard Meredith-Hardy 2001-2002 rmh@flymicro.com

This Help File

Version 1.4 9 September 2002

© Richard Meredith-Hardy rmh@flymicro.com

All other products mentioned in DirectLoad documentation are © and TM their respective owners.